<h1 align="center">🎵 daamusic — Music Streaming CLI</h1>

<p align="center">
  A terminal-based YouTube music streamer built in Python.<br/>
  Simple. Offline-ready. MPV-powered.
</p>

<p align="center">
  <a href="https://pypi.org/project/daa_music/"><img src="https://img.shields.io/pypi/v/daa_music.svg?color=blue" alt="PyPI version"></a>
  <a href="https://github.com/kamalkoranga/daamusic/blob/main/LICENSE"><img src="https://img.shields.io/github/license/kamalkoranga/daamusic.svg" alt="License"></a>
  <a href="https://github.com/kamalkoranga/daamusic/stargazers"><img src="https://img.shields.io/github/stars/kamalkoranga/daamusic.svg?style=social"></a>
  <img src="https://img.shields.io/badge/python-3.10%2B-blue.svg" alt="Python 3.10+">
</p>

---

## 📦 What is daamusic?

**daamusic** is a Python command-line tool that streams audio from YouTube directly in your terminal using `mpv`. It handles everything — from installing `mpv` to keeping the terminal clean.

> 🧪 Built as a DAA (Design & Analysis of Algorithms) PBL project in 4th Semester.

---

## 🚀 Features

- 🔊 Stream music from YouTube
- 💻 Clean terminal interface
- ⚙️ Automatically downloads `mpv` on Windows/MacOs/Linux
- 🎯 Caches `mpv` to avoid repeat downloads
- 📡 Plays URL or lets you interactively search
- 🧠 Written with simplicity and DAA concepts in mind

---

## 🧩 Installation

### From PyPI

```bash
pip install daa_music
```

Then run:

```bash
daamusic
```
---

### From GitHub (Latest Dev Version)

```bash
pip install git+https://github.com/kamalkoranga/daamusic.git
```
---

## 🎮 Usage

### Interactive Search Mode

```bash
daamusic
```

---

## 🎛️ Interactive Controls

While the song is playing, use:

- `←` / `→` : Skip backward/forward 5 seconds  
- `↑` / `↓` : Skip backward/forward 1 minute  
- `Space`   : Pause / Play  
- `m`       : Mute  
- `q`       : Quit / Close the player  

---

## 🛠️ Contributing

Pull requests are welcome!

1. Fork the repository  
2. Create a new feature branch  
3. Make your changes  
4. Open a PR  

---

## 📜 License

This project is licensed under the MIT License.  
See [LICENSE](LICENSE) for more information.

---

## 🔗 Links

- PyPI: [daa_music](https://pypi.org/project/daa_music/)  
- GitHub: [kamalkoranga/daamusic](https://github.com/kamalkoranga/daamusic)  
- MPV: [https://mpv.io/](https://mpv.io/) 
